/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)2003 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: ppmdeplex.c,v 1.1 2003/03/30 06:07:52 babolo Exp $";
#endif /* not lint */

#include <sys/types.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <sysexits.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <stdio.h>
#include <err.h>

#define FL_TEST 0x01

#define C_cl  0x0100
#define C_wp  0x0200
#define C_hp  0x0400
#define C_cp  0x0800
#define C_er  0x1000
#define C_state 0xFF

#define Tl 0x01
#define Tr 0x02
#define Tu 0x04
#define Td 0x08

enum statt {n0, n1, b0, c0, wi, b1, c1, hg, b2, c2, co, sx};
enum ich {nb0, nb1, nb2, nb3,  nb4, nb5, nb6, nb7,  nb8, nb9, beg, scm, wsp, eol, bad, cxx};

int flag_v;
enum ich chtab[256] =
/* 0    1    2    3     4    5    6    7     8    9    A    B     C    D    E    F */
{ wsp, wsp, wsp, wsp,  wsp, wsp, wsp, wsp,  wsp, wsp, eol, wsp,  wsp, eol, wsp, wsp /*0*/
, wsp, wsp, wsp, wsp,  wsp, wsp, wsp, wsp,  wsp, wsp, wsp, wsp,  wsp, wsp, wsp, wsp /*1*/
, wsp, bad, bad, scm,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*2*/
, nb0, nb1, nb2, nb3,  nb4, nb5, nb6, nb7,  nb8, nb9, bad, bad,  bad, bad, bad, bad /*3*/

, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*4*/
, beg, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*5*/
, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*6*/
, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*7*/

, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*8*/
, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*9*/
, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*A*/
, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*B*/

, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*C*/
, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*D*/
, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*E*/
, bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad,  bad, bad, bad, bad /*F*/
};

u_int32_t automa[cxx][sx] =
/*     n0,     n1,     b0,c0,     wi,     b1,c1,     hg,     b2,c2,     co */
{{C_er|sx,C_er|sx,C_wp|wi,c0,C_wp|wi,C_hp|hg,c1,C_hp|hg,C_cp|co,c2,C_cp|co} /*0*/
,{C_er|sx,C_er|sx,C_wp|wi,c0,C_wp|wi,C_hp|hg,c1,C_hp|hg,C_cp|co,c2,C_cp|co} /*1*/
,{C_er|sx,C_er|sx,C_wp|wi,c0,C_wp|wi,C_hp|hg,c1,C_hp|hg,C_cp|co,c2,C_cp|co} /*2*/
,{C_er|sx,C_er|sx,C_wp|wi,c0,C_wp|wi,C_hp|hg,c1,C_hp|hg,C_cp|co,c2,C_cp|co} /*3*/
,{C_er|sx,C_er|sx,C_wp|wi,c0,C_wp|wi,C_hp|hg,c1,C_hp|hg,C_cp|co,c2,C_cp|co} /*4*/
,{C_er|sx,C_er|sx,C_wp|wi,c0,C_wp|wi,C_hp|hg,c1,C_hp|hg,C_cp|co,c2,C_cp|co} /*5*/
,{C_er|sx,C_cl|b0,C_wp|wi,c0,C_wp|wi,C_hp|hg,c1,C_hp|hg,C_cp|co,c2,C_cp|co} /*6*/
,{C_er|sx,C_er|sx,C_wp|wi,c0,C_wp|wi,C_hp|hg,c1,C_hp|hg,C_cp|co,c2,C_cp|co} /*7*/
,{C_er|sx,C_er|sx,C_wp|wi,c0,C_wp|wi,C_hp|hg,c1,C_hp|hg,C_cp|co,c2,C_cp|co} /*8*/
,{C_er|sx,C_er|sx,C_wp|wi,c0,C_wp|wi,C_hp|hg,c1,C_hp|hg,C_cp|co,c2,C_cp|co} /*9*/
,{     n1,C_er|sx,C_er|sx,c0,C_er|sx,C_er|sx,c1,C_er|sx,C_er|sx,c2,C_er|sx} /*P*/
,{C_er|sx,C_er|sx,     c0,c0,     c1,     c1,c1,     c2,     c2,c2,C_er|sx} /*#*/
,{C_er|sx,C_er|sx,     b0,c0,     b1,     b1,c1,     b2,     b2,c2,     sx} /* */
,{C_er|sx,C_er|sx,     b0,b0,     b1,     b1,b1,     b2,     b2,b2,     sx} /*/*/
,{C_er|sx,C_er|sx,C_er|sx,c0,C_er|sx,C_er|sx,c1,C_er|sx,C_er|sx,c2,C_er|sx} /*X*/
};

int tcount[] = {0, 1, 1, 2, 1, 2, 2, 3, 1, 2, 2, 3, 2, 3, 3, 4};

void
usage(int ex, char *nm) {
    printf("%s infile outfile1 outfile2\n", nm);
    exit(ex);
}

int
main(int argc, char **argv) {
    int c, in, w, h;
    char *nm, *pic, *p, *pmax;
    FILE *out1, *out2;
    enum statt state;
    u_int32_t control, t;
    int pwi, phg, pco;
    struct stat sb;
    u_int32_t flags;

    flag_v = 1;
    flags = 0;
    nm = "";
    if  (argc > 0 && argv && *argv) {
        nm = rindex(*argv, '/');
        if  (!nm) nm = *argv;
          else nm++;
    }
    while ((c = getopt(argc, argv, "?hqtv")) != EOF) {
        switch (c) {
        case 'q':
            flag_v = 0;
            break;
        case 't':
            flags |= FL_TEST;
            break;
        case 'v':
            flag_v++;
            break;
        case 'h':
        case '?':
            usage(EX_OK, nm);
        default:
            usage(EX_USAGE, nm);
    }   }
    argc -= optind;
    argv += optind;
    if  (argc != 3 ) usage(EX_USAGE, nm);
    in = open(*argv, O_RDONLY);
    if  (in < 0) {
        if  (flag_v) warn("000");
        exit(EX_NOINPUT);
    }
    if  (fstat(in, &sb) < 0) {
        if  (flag_v) warn("001");
        exit(EX_NOINPUT);
    }
    pic = mmap(NULL, sb.st_size, PROT_READ, MAP_PRIVATE, in, 0);
    if  (pic == MAP_FAILED) {
        if  (flag_v) warn("002");
        exit(EX_NOINPUT);
    }
    pmax = &pic[sb.st_size];
    out1 = fopen(argv[1], "w");
    if  (out1 == NULL) {
        if  (flag_v) warn("005");
        exit(EX_CANTCREAT);
    }
    out2 = fopen(argv[2], "w");
    if  (out2 == NULL) {
        if  (flag_v) warn("006");
        exit(EX_CANTCREAT);
    }
    p = pic;
    control = 0;
    for (state = n0; state < sx; p++) {
        if  (p >= pmax) {
            if  (flag_v) fprintf(stderr, "%s: 010: header out of file bounds\n", nm);
            exit(EX_DATAERR);
        }
        control = automa[chtab[*p]][state];
        if  (control & C_cl) pwi = phg = pco = 0;
        if  (control & C_wp) pwi = pwi * 10 + chtab[*p];
        if  (control & C_hp) phg = phg * 10 + chtab[*p];
        if  (control & C_cp) pco = pco * 10 + chtab[*p];
        if  (control & C_er) {
            if  (flag_v) fprintf(stderr, "%s: 011: ppm syntax error\n", nm);
            exit(EX_DATAERR);
        }
        state = control & C_state;
    }
    if  (pco > 255) {
        if  (flag_v) fprintf(stderr, "%s: 012: more then 8 bit color components\n", nm);
        exit(EX_DATAERR);
    }
    if  (pwi * phg * 3 + p > pmax) {
        if  (flag_v)
            fprintf(stderr, "%s: 013: need %d length, have %d\n", nm, pwi * phg * 3 + p, pmax);
        exit(EX_DATAERR);
    }
    if  (fwrite(pic, 1, p - pic, out1) != p - pic) {
        if  (flag_v) warn("015");
        exit(EX_IOERR);
    }
    if  (fwrite(pic, 1, p - pic, out2) != p - pic) {
        if  (flag_v) warn("016");
        exit(EX_IOERR);
    }
#define pR(y, x) (*(p + ((y) * pwi * 3) + ((x) * 3)) & 0xFF)
#define pG(y, x) (*(p + ((y) * pwi * 3) + ((x) * 3) + 1) & 0xFF)
#define pB(y, x) (*(p + ((y) * pwi * 3) + ((x) * 3) + 2) & 0xFF)
    for (h = 0; h < phg; h++) {
        for (w = 0; w < pwi; w++) {
            int r, g, b;
            t = Tl|Tu|Tr|Td;
            if  (w == 0) t &= ~Tl;
            if  (h == 0) t &= ~Tu;
            if  (w == pwi - 1) t &= ~Tr;
            if  (h == phg - 1) t &= ~Td;
            r = g = b = 0;
            if  (t & Tl) {
                r += pR(h, w - 1);
                g += pG(h, w - 1);
                b += pB(h, w - 1);
            }
            if  (t & Tr) {
                r += pR(h, w + 1);
                g += pG(h, w + 1);
                b += pB(h, w + 1);
            }
            if  (t & Tu) {
                r += pR(h - 1, w);
                g += pG(h - 1, w);
                b += pB(h - 1, w);
            }
            if  (t & Td) {
                r += pR(h + 1, w);
                g += pG(h + 1, w);
                b += pB(h + 1, w);
            }
            r /= tcount[t];
            g /= tcount[t];
            b /= tcount[t];
            if  (flags & FL_TEST) r = g = b = 0;
            if  ((h ^ w) & 1) {
                if  (fwrite(p + (h * pwi * 3) + (w * 3), 1, 3, out1) != 3) {
                    if  (flag_v) warn("020");
                    exit(EX_IOERR);
                }
                if  (fputc(r, out2) == EOF || fputc(g, out2) == EOF || fputc(b, out2) == EOF) {
                    if  (flag_v) warn("021");
                    exit(EX_IOERR);
                }
            } else {
                if  (fwrite(p + (h * pwi * 3) + (w * 3), 1, 3, out2) != 3) {
                    if  (flag_v) warn("022");
                    exit(EX_IOERR);
                }
                if  (fputc(r, out1) == EOF || fputc(g, out1) == EOF || fputc(b, out1) == EOF) {
                    if  (flag_v) warn("023");
                    exit(EX_IOERR);
    }   }   }   }
    if  (fclose(out1) == EOF) {
        if  (flag_v) warn("090");
        exit(EX_CANTCREAT);
    }
    if  (fclose(out2) == EOF) {
        if  (flag_v) warn("091");
        exit(EX_CANTCREAT);
    }
    exit(EX_OK);
}
